diff --git a/game/core/src/main/java/net/minecraft/core/sound/BlockSounds.java b/game/core/src/main/java/net/minecraft/core/sound/BlockSounds.java
index f7e38683b..a4938201a 100644
--- a/game/core/src/main/java/net/minecraft/core/sound/BlockSounds.java
+++ b/game/core/src/main/java/net/minecraft/core/sound/BlockSounds.java
@@ -7,11 +7,18 @@ public abstract class BlockSounds
     public static final BlockSound GRAVEL = new BlockSound("step.gravel", "step.gravel", 1.0F, 1.0F);
     public static final BlockSound GRASS = new BlockSound("step.grass", "step.grass", 1.0F, 1.0F);
     public static final BlockSound STONE = new BlockSound("step.stone", "step.stone", 1.0F, 1.0F);
-    public static final BlockSound PERMAFROST = new BlockSound("step.permafrost", "step.permafrost", 1.0F, 1.0F);
     public static final BlockSound METAL = new BlockSound("step.stone", "step.stone", 1.0F, 1.5F);
     public static final BlockSound GLASS = new BlockSound("step.stone", "random.glass", 1.0F, 1.0F);
     public static final BlockSound CLOTH = new BlockSound("step.cloth", "step.cloth", 1.0F, 1.0F);
     public static final BlockSound SAND = new BlockSound("step.sand", "step.sand", 1.0F, 1.0F);
     public static final BlockSound FIRE = new BlockSound("", "random.fizz", 0.5F, 2.6F);
 
+    public static final BlockSound PERMAFROST = new BlockSound("step.permafrost", "step.permafrost", 1.0F, 1.0F);
+    public static final BlockSound ASH = new BlockSound("block.ash", "block.ash", 1.0F, 1.0F);
+    public static final BlockSound SOULSAND = new BlockSound("step.soulsand", "step.soulsand", 1.0F, 1.0F);
+    public static final BlockSound GLOOMSTONE = new BlockSound("step.gloomstone", "step.gloomstone", 1.0F, 1.0F);
+    public static final BlockSound BRIMSTONE = new BlockSound("step.brimstone", "step.brimstone", 1.0F, 1.0F);
+    public static final BlockSound CRYSTAL = new BlockSound("step.crystal", "step.crystal", 1.0F, 1.0F);
+
+
 }
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index f706e07a4..7abca18e0 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -4,6 +4,7 @@ package net.minecraft.core.util.helper;
 import net.minecraft.core.util.phys.HitResult;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Matrix2d;
 import org.joml.Vector3d;
 import org.joml.Vector3dc;
 import org.joml.primitives.AABBd;
@@ -528,10 +529,48 @@ public class MathHelper {
         }
     }
 
+    public static @NotNull Matrix2d rotateVec2(double radians) {
+        return new Matrix2d(Math.cos(radians), -Math.sin(radians), Math.sin(radians), Math.cos(radians));
+    }
+
     static {
         SIN_TABLE = new float[0x10000];
         for (int i = 0; i < 0x10000; i++) {
             SIN_TABLE[i] = (float) Math.sin(((double) i * Math.PI * 2D) / 65536D);
         }
     }
+
+    /**
+     * Normalizes a degree angle to the range [-180, 180).
+     */
+    public static float wrapDegrees(float value) {
+        value %= 360.0F;
+
+        if (value >= 180.0F) {
+            value -= 360.0F;
+        }
+
+        if (value < -180.0F) {
+            value += 360.0F;
+        }
+
+        return value;
+    }
+
+    /**
+     * Double version of wrapDegrees.
+     */
+    public static double wrapDegrees(double value) {
+        value %= 360.0D;
+
+        if (value >= 180.0D) {
+            value -= 360.0D;
+        }
+
+        if (value < -180.0D) {
+            value += 360.0D;
+        }
+
+        return value;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/LevelListener.java b/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
index 9312da9e5..96a6e15e7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -62,6 +62,10 @@ public interface LevelListener
      * Bit 7: Unused (Reserved) <div></div>
      */
     int EVENT_CONDUIT_SURFACE_PARTICLES = 1009;
+    /**
+     * data: unused
+     */
+    int EVENT_ACID_SPREAD = 1010;
 
 	/**
 	 * Redraw block in singleplayer and send block change packet in multiplayer. <br>
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 5f83f8b14..c3968a005 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.longs.LongOpenHashSet;
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import it.unimi.dsi.fastutil.objects.ObjectLinkedOpenHashSet;
 import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
@@ -47,6 +48,7 @@ import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.lighting.LightingEngine;
 import net.minecraft.core.world.lighting.LightingEngineLegacy;
+import net.minecraft.core.world.particle.ParticleEmitterRegistry;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
 import net.minecraft.core.world.pos.*;
@@ -113,11 +115,14 @@ public abstract class World implements MutableWorldSource {
     public final @NotNull List<@NotNull AABBdc> collidingBoundingBoxes = new ObjectArrayList<>();
 
     private final @NotNull List<@NotNull LevelListener> listeners = new ObjectArrayList<>();
-    private final @NotNull Set<@NotNull ChunkPosc> positionsToUpdate = new ObjectOpenHashSet<>();
+    private final @NotNull LongOpenHashSet positionsToUpdate = new LongOpenHashSet();
     private final @NotNull List<@NotNull Entity> entityBuffer = new ObjectArrayList<>();
     private final @NotNull Set<@NotNull NextTickListEntry> immediatelyUpdatedPositions = new ObjectOpenHashSet<>();
 
+    public final ParticleEmitterRegistry particleEmitters = new ParticleEmitterRegistry();
+
     public final @NotNull Random rand = new Random();
+    private final AABBd workingBox = new AABBd();
     public final @NotNull Dimension dimension;
     public final boolean isNewWorld;
 
@@ -638,7 +643,7 @@ public abstract class World implements MutableWorldSource {
 
     public boolean setBlockTypeDataEntity(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data, final @NotNull TileEntity entity) {
         if (!tilePos.inBounds(this)) return false;
-        
+
         final var c = this.getChunk(tilePos);
         final var ctp = new ChunkTilePos(tilePos);
         final var prevBlock = c.getBlock(ctp);
@@ -742,6 +747,11 @@ public abstract class World implements MutableWorldSource {
     public boolean setBlockTypeNotify(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (this.setBlockType(tilePos, block)) {
             this.notifyBlockChange(tilePos, block);
+
+            TilePos pos = new TilePos(tilePos);
+            this.scheduleLightingUpdate(LightLayer.Block, pos);
+            this.scheduleLightingUpdate(LightLayer.Sky, pos);
+
             return true;
         }
 
@@ -765,6 +775,11 @@ public abstract class World implements MutableWorldSource {
     public boolean setBlockTypeDataNotify(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data) {
         if (this.setBlockTypeData(tilePos, block, data)) {
             this.notifyBlockChange(tilePos, block);
+
+            TilePos pos = new TilePos(tilePos);
+            this.scheduleLightingUpdate(LightLayer.Block, pos);
+            this.scheduleLightingUpdate(LightLayer.Sky, pos);
+
             return true;
         }
 
@@ -846,7 +861,7 @@ public abstract class World implements MutableWorldSource {
      * or the block at the given position if null.
      */
     public void notifyBlocksInRadiusOfNeighborChange(
-        final int radius, 
+        final int radius,
         final @NotNull TilePosc tilePos, final @Nullable Block<?> block
     ) {
         if (this.noNeighborUpdate || this.isClientSide) return;
@@ -1122,6 +1137,7 @@ public abstract class World implements MutableWorldSource {
                 return hitResult;
             }
         }
+        final Vector3d startCopy = new Vector3d(start2);
         for (int l1 = 200; l1-- >= 0; ) {
             if (!start2.isFinite()) {
                 return null;
@@ -1200,7 +1216,6 @@ public abstract class World implements MutableWorldSource {
                 start2.y += d7 * d5;
                 start2.z = d2;
             }
-            final Vector3d startCopy = new Vector3d(start2);
             blockStart.x = (int) (startCopy.x = MathHelper.floor(start2.x()));
             if (byte0 == 5) {
                 blockStart.x--;
@@ -1249,6 +1264,13 @@ public abstract class World implements MutableWorldSource {
         }
     }
 
+    public void playSoundEffectAtTile(@Nullable final Entity player, final SoundCategory category, TilePosc tilePosc, final String soundPath,
+                                      final float volume, final float pitch) {
+        for (final LevelListener listener : this.listeners) {
+            listener.playSound(player, soundPath, category, tilePosc.x(), tilePosc.y(), tilePosc.z(), volume, pitch);
+        }
+    }
+
     public void playBlockSoundEffect(@Nullable final Entity player, final double x, final double y, final double z, final @NotNull Block<?> block, final EnumBlockSoundEffectType soundType) {
         final BlockSound sound = block.getSound();
         if (sound == null) return;
@@ -1415,7 +1437,7 @@ public abstract class World implements MutableWorldSource {
         }
 
         final double radius = 0.25D;
-        final List<Entity> entities = this.getEntitiesWithinAABBExcludingEntity(entity, MathHelper.aabbGrow(aabb, radius, radius, radius, new AABBd()));
+        final List<Entity> entities = this.getEntitiesWithinAABBExcludingEntity(entity, MathHelper.aabbGrow(aabb, radius, radius, radius, workingBox));
         for (final Entity e : entities) {
             final AABBdc entityBB = e.getCollisionAABB();
             if (entityBB != null && entityBB.intersectsAABB((AABBd) aabb)) {
@@ -1454,7 +1476,7 @@ public abstract class World implements MutableWorldSource {
         }
 
         final double d = 0.25D;
-        final List<Entity> list = this.getEntitiesWithinAABBExcludingEntity(entity, MathHelper.aabbGrow(aabb, d, d, d, new AABBd()));
+        final List<Entity> list = this.getEntitiesWithinAABBExcludingEntity(entity, MathHelper.aabbGrow(aabb, d, d, d, workingBox));
         for (int j2 = 0; j2 < list.size(); j2++) {
             final AABBdc collisionBB = list.get(j2).getCollisionAABB();
             if (collisionBB != null && collisionBB.intersectsAABB((AABBd) aabb)) {
@@ -2199,8 +2221,8 @@ public abstract class World implements MutableWorldSource {
             final byte radius = 9;
             for (int x = -radius; x <= radius; x++) {
                 for (int z = -radius; z <= radius; z++) {
-                    this.positionsToUpdate.add(new ChunkPos(x + playerChunkX, z + playerChunkZ));
-                }
+                    long packedChunkPos = ((long) (x + playerChunkX) & 0xFFFFFFFFL) | (((long) (z + playerChunkZ) & 0xFFFFFFFFL) << 32);
+                    this.positionsToUpdate.add(packedChunkPos);}
             }
         }
 
@@ -2210,13 +2232,19 @@ public abstract class World implements MutableWorldSource {
         ChunkTilePos chunkTileQueryPos = new ChunkTilePos();
         TilePos tileQueryPos = new TilePos();
         final int randomTicks = this.getGameRuleValue(GameRules.RANDOM_TICK_SPEED);
-        for (final ChunkPosc chunkPos : this.positionsToUpdate) {
-            final int chunkBlockX = chunkPos.x() * Chunk.CHUNK_SIZE_X;
-            final int chunkBlockZ = chunkPos.z() * Chunk.CHUNK_SIZE_Z;
-            if (!this.isChunkLoaded(chunkPos)) {
+        it.unimi.dsi.fastutil.longs.LongIterator iterator = this.positionsToUpdate.iterator();
+        while (iterator.hasNext()) {
+            long packedPos = iterator.nextLong();
+            int cX = (int) packedPos;          // Unpack X
+            int cZ = (int) (packedPos >> 32);  // Unpack Z
+
+            final int chunkBlockX = cX * Chunk.CHUNK_SIZE_X;
+            final int chunkBlockZ = cZ * Chunk.CHUNK_SIZE_Z;
+
+            if (!this.isChunkLoaded(cX, cZ)) {
                 continue;
             }
-            final Chunk chunk = this.getChunk(chunkPos);
+            final Chunk chunk = this.getChunkFromChunkCoords(cX, cZ);
             this.updateLCG = this.updateLCG * 3 + 0x3c6ef35f;
             int randVal = this.updateLCG >> 2;
             int blockX = randVal & (Chunk.CHUNK_SIZE_X - 1);
@@ -2292,18 +2320,18 @@ public abstract class World implements MutableWorldSource {
 
     public void randomDisplayUpdates(final @NotNull TilePos tilePos) {
         final int radius = 16;
-        final @NotNull Random random = new Random();
-
+        final @NotNull Random random = this.rand;
         final TilePos randomPos = new TilePos();
         for (int i = 0; i < ANIMATION_TICKS_PER_TICK; i++) {
             tilePos.add(
-                this.rand.nextInt(radius) - this.rand.nextInt(radius),
-                this.rand.nextInt(radius) - this.rand.nextInt(radius),
-                this.rand.nextInt(radius) - this.rand.nextInt(radius),
-                randomPos);
+                random.nextInt(radius) - random.nextInt(radius),
+                random.nextInt(radius) - random.nextInt(radius),
+                random.nextInt(radius) - random.nextInt(radius),
+                randomPos
+            );
 
-            final @Nullable Block<?> block = this.getBlockType(randomPos);
-            if (block != null) {
+            if (this.isBlockLoaded(randomPos)) {
+                final @Nullable Block<?> block = this.getBlockType(randomPos);
                 block.animationTick(this, randomPos, random);
             }
         }
@@ -2539,12 +2567,12 @@ public abstract class World implements MutableWorldSource {
     }
 
     public boolean hasNeighborSignal(final @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         for (final @NotNull Side side : Side.sides) {
-            if (this.hasSignal(tilePos.add(side.direction(), new TilePos()), side)) {
+            if (this.hasSignal(tilePos.add(side.direction(), queryPos), side)) {
                 return true;
             }
         }
-
         return false;
     }
 
@@ -2585,6 +2613,19 @@ public abstract class World implements MutableWorldSource {
         return entityplayer;
     }
 
+    public List<Player> getPlayersWithinRange(final double x, final double y, final double z, final double radius) {
+        List<Player> playersInRange = new ArrayList<>();
+        final double rSquared = radius * radius;
+
+        for (final Player player : this.players) {
+            if (player.distanceToSqr(x, y, z) <= rSquared) {
+                playersInRange.add(player);
+            }
+        }
+
+        return playersInRange;
+    }
+
 
     public Player getPlayerEntityByName(final String s) {
         for (final Player player : this.players) {
@@ -2968,4 +3009,8 @@ public abstract class World implements MutableWorldSource {
     public int renderDistance() {
         return 12;
     }
+
+    public int getParticleRenderDistance() {
+        return 1; //chunks
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index 28ade554b..3464bea6f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -50,6 +50,7 @@ public class Biome
     public float defaultHumidity = 0.5f;
     public float defaultVariety = 0.5f;
     private @NotNull SurfaceProperties surfaceProperties;
+    private @Nullable String registryKey;
 
     public Biome(final @NotNull String key) {
         this.translationKey = "biome." + key;
@@ -181,6 +182,14 @@ public class Biome
         }
     }
 
+    void bindRegistryKey(final @NotNull String key) {
+        this.registryKey = key;
+    }
+
+    public @Nullable String getRegistryKey() {
+        return this.registryKey;
+    }
+
     public boolean hasTag(final @NotNull Tag<Biome> tag) {
         return tag.appliesTo(this);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 6553f0b42..3389965b3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -216,7 +216,7 @@ public class Biomes {
             .withSurfaceProperties(
                 new SurfaceProperties.Builder()
                     .withTopBlock(Blocks.BRIMSAND)
-                    .withFillerBlock(Blocks.BRIMSAND)
+                    .withFillerBlock(Blocks.BRIMSTONE)
                     .build()
             )
     );
@@ -227,8 +227,8 @@ public class Biomes {
             .withBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG)
             .withSurfaceProperties(
                 new SurfaceProperties.Builder()
-                    .withTopBlock(Blocks.BRIMSAND)
-                    .withFillerBlock(Blocks.BRIMSAND)
+                    .withTopBlock(Blocks.BRIMSTONE)
+                    .withFillerBlock(Blocks.BRIMSTONE)
                     .build()
             )
             .withTags(BiomeTags.HAS_SULFUR_POOLS)
@@ -298,6 +298,8 @@ public class Biomes {
             )
     );
 
+
+
     public static final @NotNull Biome DRIFT_DRIFT = register(
         "minecraft:drift.drift",
         new BiomeDrift("drift.drift")
@@ -379,6 +381,7 @@ public class Biomes {
     );
 
     public static @NotNull Biome register(final @NotNull String key, final @NotNull Biome biome) {
+        biome.bindRegistryKey(key);
         Registries.BIOMES.register(key, biome);
         return biome;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index c17d7b859..199476ffc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -3,46 +3,44 @@ package net.minecraft.core.world.biome.provider;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.data.BiomeRange;
+import net.minecraft.core.world.biome.data.BiomeRangeMap;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.FractalNoise3D;
 import net.minecraft.core.world.noise.SimplexNoise;
-import net.minecraft.core.world.type.WorldTypes;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
+import java.util.Set;
+
+public final class BiomeProviderNether extends BiomeProvider {
+    public static final BiomeRangeMap brm = new BiomeRangeMap();
+    private static Biome[] biomes;
+
+    private static final double NETHER_BIOME_PATCH_SIZE_FRACTION = 0.75;
+    private static final double BIOME_STRETCH_FACTOR = 2.0 * NETHER_BIOME_PATCH_SIZE_FRACTION;
+
+    private static final double TEMP_SCALE = 0.025 / BIOME_STRETCH_FACTOR;
+    private static final double DOWNFALL_SCALE = 0.05 / BIOME_STRETCH_FACTOR;
+    private static final double NOISE_SCALE = 0.25F / BIOME_STRETCH_FACTOR;
 
-public final class BiomeProviderNether
-    extends BiomeProvider
-{
-    public static final Biome[] BIOMES_ORDER = {
-            Biomes.NETHER_OLD_WORLD,
-            Biomes.NETHER_CRYSTAL_PLAINS,
-            Biomes.NETHER_CRYSTAL_FOREST,
-            Biomes.NETHER_SHELF,
-            Biomes.NETHER_CRAG,
-            Biomes.NETHER_SULFUR_POOLS,
-            Biomes.NETHER_VOLCANIC_ISLANDS,
-    };
-
-    private static final double TEMP_SCALE = 0.025;
-    private static final double DOWNFALL_SCALE = 0.05;
-    private static final double NOISE_SCALE = 0.25;
     private final FractalNoise2D<?> temperatureNoise;
     private final FractalNoise2D<?> downfallNoise;
     private final FractalNoise2D<?> fuzzinessNoise;
 
-    public BiomeProviderNether(final @NotNull World world)
-    {
-        super(world);
+    static {
+        init();
+    }
 
-        final long seed = world.getRandomSeed();
-        this.temperatureNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 9871, 4));
-        this.downfallNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 39811, 4));
-        this.fuzzinessNoise = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 543321, 4));
+    public BiomeProviderNether(@NotNull World world) {
+        super(world);
+        long seed = world.getRandomSeed();
+        this.temperatureNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 9871L, 4));
+        this.downfallNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 39811L, 4));
+        this.fuzzinessNoise = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 543321L, 4));
     }
 
-    @Override
-    public Biome[] getBiomes(Biome[] biomes, double[] temperatures, double[] humidities, double[] varieties, final int x, final int y, final int z, final int xSize, final int ySize, final int zSize) {
+    public Biome[] getBiomes(Biome[] biomes, double[] temperatures, double[] humidities, double[] varieties, int x, int y, int z, int xSize, int ySize, int zSize) {
         if (biomes == null || biomes.length < xSize * ySize * zSize) {
             biomes = new Biome[xSize * ySize * zSize];
         }
@@ -93,102 +91,131 @@ public final class BiomeProviderNether
 
                 temperatures[xx * zSize + zz] = temperature;
                 humidities[xx * zSize + zz] = downfall;
+                double variety = varieties[xx * zSize + zz];
 
-                for (int yy = 0; yy < ySize; yy++) {
-                    biomes[yy * xSize * zSize + zz * xSize + xx] = this.lookupBiome(temperature, downfall, 0.0, 0.0);
+                for (int yy = 0; yy < ySize; ++yy) {
+                    double actualY = (double) y + yy;
+                    double altitude = actualY / 128.0;
+                    altitude = Math.max(0.0, Math.min(1.0, altitude));
+
+                    biomes[yy * xSize * zSize + zz * xSize + xx] = this.lookupBiome(temperature, downfall, altitude, variety);
                 }
             }
         }
-
         return biomes;
     }
 
-    @Override
-    public double[] getTemperatures(double[] temperatures, final int x, final int z, final int xSize, final int zSize) {
+    public double[] getTemperatures(double[] temperatures, int x, int z, int xSize, int zSize) {
         if (temperatures == null || temperatures.length < xSize * zSize) {
             temperatures = new double[xSize * zSize];
         }
-        this.temperatureNoise.setLacunarity(0.25).getRegion(temperatures, x, z, xSize, xSize, TEMP_SCALE, TEMP_SCALE);
 
-        final double @NotNull [] noises = this.fuzzinessNoise.setLacunarity(10.0 / 17.0).getRegion(null, x, z, xSize, zSize, NOISE_SCALE, NOISE_SCALE);
+        this.temperatureNoise.setLacunarity(0.25F).getRegion(temperatures, x, z, xSize, xSize, TEMP_SCALE, TEMP_SCALE);
+        double[] noises = this.fuzzinessNoise.setLacunarity(0.5882352941176471).getRegion(null, x, z, xSize, zSize, NOISE_SCALE, NOISE_SCALE);
 
         int i = 0;
-        for (int xx = 0; xx < xSize; xx++) {
-            for (int zz = 0; zz < zSize; zz++) {
-                final double a = noises[i] * 1.1 + 0.5;
-                final double b = 0.01;
-                final double c = 1.0 - b;
+        for (int xx = 0; xx < xSize; ++xx) {
+            for (int zz = 0; zz < zSize; ++zz) {
+                double a = noises[i] * 1.1 + 0.5;
+                double b = 0.01;
+                double c = 0.99;
                 double temperature = (temperatures[i] * 0.15 + 0.7) * c + a * b;
                 temperature = 1.0 - (1.0 - temperature) * (1.0 - temperature);
-
-                if (temperature < 0.0) {
-                    temperature = 0.0;
-                }
-                if (temperature > 1.0) {
-                    temperature = 1.0;
-                }
-
-                temperatures[i++] = temperature;
+                temperatures[i++] = Math.max(0.0, Math.min(1.0, temperature));
             }
         }
-
         return temperatures;
     }
 
-    @Override
-    public double[] getHumidities(double[] humidities, final int x, final int z, final int xSize, final int zSize) {
+    public double[] getHumidities(double[] humidities, int x, int z, int xSize, int zSize) {
         if (humidities == null || humidities.length < xSize * zSize) {
             humidities = new double[xSize * zSize];
         }
-        return this.downfallNoise.setLacunarity(0.5).getRegion(humidities, x, z, xSize, zSize, DOWNFALL_SCALE, DOWNFALL_SCALE);
+        return this.downfallNoise.setLacunarity(0.5F).getRegion(humidities, x, z, xSize, zSize, DOWNFALL_SCALE, DOWNFALL_SCALE);
     }
 
-    @Override
-    public double[] getVarieties(double[] varieties, final int x, final int z, final int xSize, final int zSize) {
+    public double[] getVarieties(double[] varieties, int x, int z, int xSize, int zSize) {
         if (varieties == null || varieties.length < xSize * zSize) {
             varieties = new double[xSize * zSize];
         }
-        Arrays.fill(varieties, 0.0);
 
+        Arrays.fill(varieties, 0.0F);
         return varieties;
     }
 
-    @Override
     public double[] getBiomenesses(double[] biomenesses, int x, int y, int z, int xSize, int ySize, int zSize) {
-        if (biomenesses == null || biomenesses.length < xSize * ySize * zSize)
-        {
+        if (biomenesses == null || biomenesses.length < xSize * ySize * zSize) {
             biomenesses = new double[xSize * ySize * zSize];
         }
 
-        Arrays.fill(biomenesses, 1.0f);
-
+        Arrays.fill(biomenesses, 1.0F);
         return biomenesses;
     }
 
-    @Override
     public Biome lookupBiome(double temperature, double humidity, double altitude, double variety) {
+        return brm.lookupBiome(temperature, humidity, altitude, variety);
+    }
 
-        if (temperature <= 0.2) {
-            return Biomes.NETHER_OLD_WORLD;
-        }
-        if (temperature < 0.65) {
-            return humidity < 0.1 ? Biomes.NETHER_CRYSTAL_PLAINS : Biomes.NETHER_CRYSTAL_FOREST;
-        }
-
-        if (temperature <= 0.75) {
-            return Biomes.NETHER_SHELF;
-        }
-
-        if(humidity > 0.85) {
-            return Biomes.NETHER_SULFUR_POOLS;
-        }
-        if(temperature >= 0.95 && humidity < 0.1) {
-            return Biomes.NETHER_VOLCANIC_ISLANDS;
-        }
-        return Biomes.NETHER_CRAG;
+    public static void init() {
+        brm.clear();
+
+        // Hot Biomes
+        brm.addRange(Biomes.NETHER_VOLCANIC_ISLANDS, new BiomeRange(
+                0.95, 1.0,
+                0.0, 1.0,
+                0.5, 1.0,
+                0.0, 1.0));
+        brm.addRange(Biomes.NETHER_CRAG, new BiomeRange(
+                0.75, 0.95,
+                0.0, 0.85,
+                0.5, 1.0,
+                0.0, 1.0));
+        brm.addRange(Biomes.NETHER_SULFUR_POOLS, new BiomeRange(
+                0.75, 0.95,
+                0.85, 1.0,
+                0.5, 1.0,
+                0.0, 1.0));
+
+        // Mid/Warm Biome
+        brm.addRange(Biomes.NETHER_SHELF, new BiomeRange(
+                0.70, 0.75,
+                0.0, 1.0,
+                0.5, 1.0,
+                0.0, 1.0));
+
+        // Mid/Cool Biomes
+        brm.addRange(Biomes.NETHER_CRYSTAL_FOREST, new BiomeRange(
+                0.45, 0.70,
+                0.1, 1.0,
+                0.5, 1.0,
+                0.0, 1.0));
+        brm.addRange(Biomes.NETHER_CRYSTAL_PLAINS, new BiomeRange(
+                0.45, 0.70,
+                0.0, 0.1,
+                0.5, 1.0,
+                0.0, 1.0));
+
+        // Coldest Biome
+        brm.addRange(Biomes.NETHER_OLD_WORLD, new BiomeRange(
+                0.0, 0.45,
+                0.0, 1.0,
+                0.50, 1.0,
+                0.0, 1.0));
+
+        // Underground Desert
+        brm.addRange(Biomes.NETHER_OLD_WORLD_DESERT, new BiomeRange(
+                0.0, 1.0,
+                0.0, 1.0,
+                0.0, 0.5,
+                0.0, 1.0));
+
+        brm.lock();
+
+        Set<Biome> allBiomes = brm.allBiomes();
+        biomes = allBiomes.toArray(new Biome[0]);
     }
 
     public static Biome[] allBiomes() {
-        return BIOMES_ORDER;
+        return biomes;
     }
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 467d406c1..8f2d70dfe 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -569,6 +569,7 @@ public class Chunk {
     }
 
     public void removeEntityAtIndex(@NotNull Entity entity, int index) {
+        this.isModified = true;
         index = MathHelper.clamp(index, 0, CHUNK_SECTIONS - 1);
         getSection(index).removeEntity(entity);
     }
